with Ada.Numerics;
use Ada.Numerics;

with Ada.Numerics.Complex_Elementary_Functions;
use Ada.Numerics.Complex_Elementary_Functions;

package body ITI8590.Discrete_Fourier_Transform is

   function Canonical_Root_Of_Unity(Exponent : in Index) return Complex is
   begin
      return Exp(2.0 * Pi * i / Float(Exponent));
   end Canonical_Root_Of_Unity;

   procedure Fast_Inverse_Fourier_Transform(Data : in out Vector) is
      procedure Conjugate_All is
      begin
         for Index in Data'Range loop
            Data(Index) := Conjugate(Data(Index));
         end loop;
      end Conjugate_All;
   begin
      Conjugate_All;
      Fast_Fourier_Transform(Data);
      Conjugate_All;
      for Index in Data'Range loop
         Data(Index) := Data(Index) / Float(Data'Length);
      end loop;
   end Fast_Inverse_Fourier_Transform;

end ITI8590.Discrete_Fourier_Transform;
